close all;
clear all;

I = double(imread('Cat GEMS - Slice 4.png'));
I(:) = (I-min(I(:)))/(max(I(:))-min(I(:)));
figure(1),imagesc(I),colormap(gray),axis image;

figure(1);
[cx,cy] = ginput(2);
cx = round(cx); cy = round(cy);

offset=50;
[hI,wI] = size(I);
left = max(1,min(cx)-offset);
right = min(wI,max(cx)+offset);
up = max(1,min(cy)-offset);
down = min(hI,max(cy)+offset);

J = I(up:down,left:right);
figure(2),imagesc(J),colormap(gray),axis image;

sig = 5;
siz = 2*round(3*sig) + 1;
g = fspecial('Gaussian',[siz siz],sig);
J = imfilter(J,g,'same','same','replicate');

[Jx,Jy] = gradient(J);
smlG = sqrt(Jx.^2 + Jy.^2);
smlT = atan2(Jy, Jx);

% build an edge weight (adjacency matrix)
[h,w] = size(J);
rowC = [1:h];         rowN = [1 1:h-1];    rowS = [2:h h];
colC = [1:w];         colE = [1 1:w-1];    colW = [2:w w];

% gradient based cost function
sg=0.01;
sa=1;
CN = exp(-(smlG(rowN,colC)+smlG).^2/(2*sg^2) -(smlT(rowN,colC) - smlT).^2/(2*sa^2));
CS = exp(-(smlG(rowS,colC)+smlG).^2/(2*sg^2) -(smlT(rowS,colC) - smlT).^2/(2*sa^2));
CE = exp(-(smlG(rowC,colE)+smlG).^2/(2*sg^2) -(smlT(rowC,colE) - smlT).^2/(2*sa^2));
CW = exp(-(smlG(rowC,colW)+smlG).^2/(2*sg^2) -(smlT(rowC,colW) - smlT).^2/(2*sa^2));
CNE = exp(-(smlG(rowN,colE)+smlG).^2/(2*sg^2) -(smlT(rowN,colE) - smlT).^2/(2*sa^2));
CSE = exp(-(smlG(rowS,colE)+smlG).^2/(2*sg^2) -(smlT(rowS,colE) - smlT).^2/(2*sa^2));
CNW = exp(-(smlG(rowN,colW)+smlG).^2/(2*sg^2) -(smlT(rowN,colW) - smlT).^2/(2*sa^2));
CSW = exp(-(smlG(rowS,colW)+smlG).^2/(2*sg^2) -(smlT(rowS,colW) - smlT).^2/(2*sa^2));

% adjacency matrix construction
% prevent wrap-around edges
CS(1:h:(w-1)*h+1)=0;
CNW(h:h:w*h)=0;
CSW(1:h:(w-1)*h+1)=0;
CN(h:h:w*h)=0;
CSE(1:h:(w-1)*h+1)=0;
CNE(h:h:w*h)=0;
% this is a quick way to build the adjacency matrix
A = spdiags([CNE(:) CE(:) CSE(:) CN(:) CS(:) CNW(:) CW(:) CSW(:)],[-h-1 -h -h+1 -1 1 h-1 h h+1],h*w,h*w);

cx = cx-left+1;
cy = cy-up+1;
figure(2),hold on; plot(cx,cy,'r*'); hold off;
u = (cx(1)-1)*h+cy(1);
[dists pred] = shortest_paths(A,u);
i=cy(2);
j=cx(2);
x=[];y=[];
figure(2),hold on;
while ~(i==cy(1) && j==cx(1))
    x = [x; j];
    y = [y; i];
    ind = pred(h*(j-1)+i);
    j = floor((ind-1)/h) + 1;
    i = ind - h*(j-1);
    plot(j,i,'r.');
end
hold off;
x=[x; cx(1)]+left-1;
y=[y; cy(1)]+up-1;
figure(1),hold on; plot(x,y,'r'); hold off;